PersistenceExceptionTranslator (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.dao.support

## Interface PersistenceExceptionTranslator

- All Known Subinterfaces:
    JpaDialect
  All Known Implementing Classes:
    AbstractEntityManagerFactoryBean, AbstractSessionFactoryBean, AnnotationSessionFactoryBean, ChainedPersistenceExceptionTranslator, DefaultJdoDialect, DefaultJpaDialect, EclipseLinkJpaDialect, HibernateExceptionTranslator, HibernateExceptionTranslator, HibernateJpaDialect, LocalContainerEntityManagerFactoryBean, LocalEntityManagerFactoryBean, LocalPersistenceManagerFactoryBean, LocalSessionFactoryBean, LocalSessionFactoryBean, OpenJpaDialect, TopLinkJpaDialect

      public interface PersistenceExceptionTranslator

  Interface implemented by Spring integrations with data access technologies that throw runtime exceptions, such as JPA, TopLink, JDO and Hibernate.

  This allows consistent usage of combined exception translation functionality, without forcing a single translator to understand every single possible type of exception.

  Since:
    2.0
  Author:
    Rod Johnson, Juergen Hoeller

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `DataAccessException` | `translateExceptionIfPossible(RuntimeException ex)` Translate the given runtime exception thrown by a persistence framework to a corresponding exception from Spring's generic DataAccessException hierarchy, if possible.

- - ### Method Detail

    - #### translateExceptionIfPossible

          DataAccessException translateExceptionIfPossible(RuntimeException ex)

      Translate the given runtime exception thrown by a persistence framework to a corresponding exception from Spring's generic DataAccessException hierarchy, if possible.

      Do not translate exceptions that are not understand by this translator: for example, if coming from another persistence framework, or resulting from user code and unrelated to persistence.

      Of particular importance is the correct translation to DataIntegrityViolationException, for example on constraint violation. Implementations may use Spring JDBC's sophisticated exception translation to provide further information in the event of SQLException as a root cause.

      Parameters:
        `ex` - a RuntimeException thrown
      Returns:
        the corresponding DataAccessException (or `null` if the exception could not be translated, as in this case it may result from user code rather than an actual persistence problem)
      See Also:
        `DataIntegrityViolationException`, `SQLExceptionTranslator`